global visobj, viss, vist

utility vis "Visibility Manager 1.2" (
	group "Convert On/Off --> Bezier" (
		pickbutton visconv "Pick Object" width:110 height:22 across:2 align:#left tooltip:"Pick object to convert visibility track"
		button visconvs "Sel" width:25 height:22 align:#right tooltip:"Get Selected object"
	)

	group "Fade Bezier Key" (
		pickbutton visfadepick "Pick Object" width:110 height:22 across:2 align:#left tooltip:"Pick object with bezier type visibility track"
		button visgets "Sel" width:25 height:22 align:#right tooltip:"Get Selected object"
		radiobuttons visfademode "Fade Mode:" labels:#("....|  ","..|..  ","|....") columns:3 enabled:false
		spinner visfadetime "Fade Time: " range:[1,100,25] type:#integer scale:5 fieldwidth:30 enabled:false
		spinner visfadekey "Fade Key: " range:[1,100,1] type:#integer fieldwidth:30 enabled:false
		label vislab "Time: "
		button visfade "FADE!" width:100 height:24 enabled:false
	)

	group "Fade Tools" (
		label visc "Copy keys:"
		pickbutton viscs "Pick Source" width:110 height:22 across:2 align:#left tooltip:"Pick source object for keys copying"
		button viscssel "Sel" width:25 height:22 tooltip:"Get Selected object" align:#right
		pickbutton visct "Pick Target" width:110 height:22 across:2 align:#left tooltip:"Pick target object for keys copying" offset:[0,-5]
		button visctsel "Sel" width:25 height:22 tooltip:"Get Selected object" align:#right offset:[0,-5]
		button viscopy "COPY" width:65 height:23 across:2 align:#left enabled:false
		button visinst "INSTANCE" width:65 height:23 align:#right enabled:false
		label visi "Invert keys:"
		pickbutton visinv "Pick Object" width:110 height:22 across:2 align:#left tooltip:"Pick object to invert visibility track"
		button visinvsel "Sel" width:25 height:22 tooltip:"Get Selected object" align:#right
	)

	button visundo "undo" width:70 height:18

	group "About VisiMan" (
		label visab1 "Visibility Manager 1.2"
		label visab2 "by Jarek Dukat"
		label visab3 "www.nautilus.com.pl/jarek"
		label visab4 "jarek@nautilus.com.pl"
	)

	on visfadepick picked node do if classof(node.visibility.controller) == bezier_float then (
		visfadekey.range = [1,node.visibility.controller.keys.count,1]
		vislab.text = "Time: " + (node.visibility.controller.keys[1].time as string)
		visobj = node.visibility.controller
		visfadepick.text = node.name
		visfademode.enabled = true
		visfadetime.enabled = true
		visfadekey.enabled = true
		visfade.enabled = true
		max select none
		select node
	) else messagebox "Picked object doesn't have\nBezier type visibility track controller" title:"VisiMan Error"
	on visgets pressed do (
		n = selection[1]
		if classof(n.visibility.controller) == bezier_float then (
			visfadekey.range = [1,n.visibility.controller.keys.count,1]
			vislab.text = "Time: " + (n.visibility.controller.keys[1].time as string)
			visobj = n.visibility.controller
			visfadepick.text = n.name
			visfademode.enabled = true
			visfadetime.enabled = true
			visfadekey.enabled = true
			visfade.enabled = true
		) else messagebox "Selected object doesn't have\nBezier type visibility track controller" title:"VisiMan Error"
	)

	on viscs picked node do if node.visibility.controller != undefined then (
		viss = node
		vis.viscs.text = node.name
		if vist != undefined do (vis.viscopy.enabled = true; vis.visinst.enabled = true)
	) else messagebox "Picked object have no visibility track" title:"VisiMan Error"
	on viscssel pressed do (
		if selection[1] == undefined then return(0) else n = selection[1]
		if n.visibility.controller != undefined then (
			viss = n
			vis.viscs.text = n.name
			if vist != undefined do (vis.viscopy.enabled = true; vis.visinst.enabled = true)
		) else messagebox "Picked object have no visibility track" title:"VisiMan Error"
	)
	on visct picked node do if node.visibility.controller != undefined then (
		vist = node
		vis.visct.text = node.name
		if viss != undefined do (vis.viscopy.enabled = true; vis.visinst.enabled = true)
	) else messagebox "Picked object have no visibility track" title:"VisiMan Error"
	on visctsel pressed do (
		if selection[1] == undefined then return(0) else n = selection[1]
		if n.visibility.controller != undefined then (
			vist = n
			vis.visct.text = n.name
			if viss != undefined do (vis.viscopy.enabled = true; vis.visinst.enabled = true)
		) else messagebox "Picked object have no visibility track" title:"VisiMan Error"
	)
	on viscopy pressed do undo on vist.visibility.controller = copy viss.visibility.controller
	on visinst pressed do undo on vist.visibility.controller = viss.visibility.controller

	on visinv picked node do if classof(node.visibility.controller) == bezier_float then undo on invertkeys node.visibility.keys
		else messagebox "Picked object doesn't have\nBezier type visibility track controller" title:"VisiMan Error"
	on visinvsel pressed do (
		if selection[1] == undefined then return(0) else n = selection[1]
		if classof(n.visibility.controller) == bezier_float then undo on invertkeys n.visibility.keys
		else messagebox "Picked object doesn't have\nBezier type visibility track controller" title:"VisiMan Error"
	)
	
	on visundo pressed do (
		max undo
		updatekey()
	)

	on visfadekey changed k do updatekey()

	on visconv picked node do undo on (
		onoff node
		max select none
		select node
	)
	on visconvs pressed do undo on
		for i=1 to selection.count do onoff selection[i]

	on visfade pressed do undo on fader()
	
	on vis open do (
		viss = undefined
		vist = undefined
	)
)

fn updatekey = if visobj != undefined do (
	deselectkeys visobj
	selectkey visobj vis.visfadekey.value
	vis.visfadekey.range = [1,visobj.keys.count,vis.visfadekey.value]
	vis.vislab.text = "Time: " + (visobj.keys[vis.visfadekey.value].time as string)
)

fn onoff node = 
	if classof(node.visibility.controller) == on_off then (
		v = bezier_float()
		vv = if node.visibility then 0 else 1
		node.visibility.controller = v
		if vv==0 do addnewkey v 0
		for i=1 to node.visibility.controller.keys.count do (
			v.keys[i].value = vv = 1 - vv
			v.keys[i].intangenttype = #step
			v.keys[i].outtangenttype = #step
		)
	) else messagebox "Selected object has no visibility track\nor track controller is not On_Off" title:"VisiMan Error"

fn fader = (
	k1 = visobj.keys[vis.visfadekey.value]
	m = 0
	if vis.visfademode.state == 1 do m = -1 * vis.visfadetime.value
	if vis.visfademode.state == 2 do m = -1 * vis.visfadetime.value / 2
	movekey visobj vis.visfadekey.value m
	k1.outtangenttype = #slow
	k2 = addnewkey visobj (k1.time + vis.visfadetime.value)
	k2.intangenttype = #slow
	k2.outtangenttype = #step
	v = k1.value
	k1.value = 1 - v
	k2.value = v
	if vis.visfadekey.value>1 then k1.value = visobj.keys[vis.visfadekey.value-1].value
	updatekey()
)

fn invertkeys k = for i = 1 to k.count do k[i].value = 1 - k[i].value
